<?php	
/**************************************************************
*  Description:
*  Creates a simple SOAP Client using WSDL (client_wsdl.php).
**************************************************************/

// use form data
if ((string)$_GET['action'] == 'get_data') {

  // includes nusoap classes
  require('inc/nusoap.php');
  
  // set parameters and create client
  $l_oClient = new soapclient('http://somewhere.org/soap/weather.wsdl', 'wsdl');
  $l_oProxy  = $l_oClient->getProxy();
   
  // call a webmethod (getWeather)
  $l_stResult = $l_oProxy->getWeather((string)$_POST['city']);
 
  // check for errors
  if (!$l_oClient->getError()) {
    // print results  
    print '<h1>>Current data for: '    . (string)$_POST['city'] 
         . ':</h1><ul><li>DEGREES: '   . $l_stResult['degrees'] 
         . '&deg;C</li><li>FORECAST: ' . $l_stResult['forecast'] 
         . '</li></ul>';

  }
  // print error description
  else {
    echo '<h1>Napaka: ' . $l_oClient->getError() . '</h1>';
  }
}
  
// output search fclientorm
print '
  <form name="input" action="'.$_SERVER['PHP_SELF'].'?action=get_data"  method="POST">
    Your city: <input type="text" name="city">
    <input type="submit" value="Search">
  </form>
';
?>
